#include<bits/stdc++.h>

#define REP(i, n) for(int i = 0; i < n; i++)

#define SIZE 123456

#define INF 1000000010

#define mp make_pair

using namespace std;

typedef pair<int, int> pii;

struct pair_hash {
    inline std::size_t operator()(const std::pair<int,int> & v) const {
        return v.first*31+v.second;
    }
};

unordered_map<pii, int, pair_hash> d;
int best_vis[SIZE];

vector<pii> e[SIZE];
int ind[SIZE];

int n, m, a, b, k;


int bfs(){
    queue<pii> q;
    q.push(pii(a, 0));

    while(!q.empty()){
        auto tmp = q.front();
        q.pop();
        int v = tmp.first, w = tmp.second;    
        if(v == b) return d[tmp];
        for(;ind[v] < e[v].size() && e[v][ind[v]].second + k >= w; ind[v]++){
            auto t = e[v][ind[v]];
            int u = t.first, c = t.second;
            if(c+k < w)continue;
            if(best_vis[u] <= c)continue;
            best_vis[u] = c;
            d[t] = d[tmp]+1;
            q.push(t);
        }
    }
    return -1;
}

bool cmp(const pii &a, const pii &b){
    return a.second >= b.second;
}

int main(){
    scanf("%d%d%d%d%d", &n, &m, &a, &b, &k);

    REP(i, n)best_vis[i] = INF;
    REP(i, n)ind[i] = 0;    

    int x, y, w;
    REP(i, m){
        scanf("%d%d%d", &x, &y, &w);
        e[x].push_back(pii(y, w));
    }

    REP(i, n)sort(e[i].begin(), e[i].end(), cmp);
 
    printf("%d\n", bfs());

    return 0;
}
